#include <bits/stdc++.h>
#ifdef LOCAL
#define dbg(x) (cerr << "ln " << __LINE__ << ": " << #x << " = " << (x) << '\n')
#else
#define dbg(x) {}
#endif
using namespace std;

typedef long long ll;

const ll MOD = 1000000007;

ll n, m, mod;

ll sum_kv(ll n) {
	ll x = n * (n+1) % MOD * (2*n+1) % MOD;
	while (x % 6) {
		x += MOD;
	}
	return x/6;
}

ll lin_sum(ll a, ll x, ll n) {
	if (n <= 0) {
		return 0;
	}
	// skalarni proizvod [a, a+1, ..., a+n-1] . [x, x+1, ..., x+n-1]

	ll z = a * x % MOD * n % MOD;

	// 0 + 1 + ... + n - 1
	ll s = n * (n-1) / 2 % MOD;
	z += (a + x) * s % MOD;

	// 0 + 1 + 4 + 9 + ... + (n-1)^2
	z += sum_kv(n-1);

	return z % MOD;
}

ll lin_sum_rev(ll a, ll x, ll n) {
	if (n <= 0) {
		return 0;
	}
	// skalarni proizvod [a, a-1, ..., a-n+1] . [x, x+1, ..., x+n+1]

	ll z = a * x % MOD * n % MOD;

	// 0 + 1 + ... + n - 1
	ll s = n * (n-1) / 2 % MOD;
	z += (a - x) * s % MOD;
	if (z < 0) {
		z += MOD;
	}

	// 0 + 1 + 4 + 9 + ... + (n-1)^2
	z -= sum_kv(n-1);
	if (z < 0) {
		z += MOD;
	}

	return z % MOD;
}

ll suma_napred(ll start, const ll br) {
	if (!br) {
		return 0;
	}
	ll z = 0, x = 0;
	// do sledece nule
	{
		ll y = mod - start;
		y = min(y, br);
		z += lin_sum(start, 1, y);
		x = y;
	}
	// zavrsio?
	if (x == br) {
		return z % MOD;
	}
	// puni krugovi
	{
		ll q = (br - x) / mod;
		ll b0 = lin_sum(0, x+1, mod);
		ll k = mod * (mod - 1) / 2 % MOD * mod % MOD;
		// b0 + (b0 + k) + ... + (b0 + (q-1)k)
		ll s = q*b0 % MOD;
		s += q * (q-1) / 2 % MOD * k % MOD;
		z += s;
		x += q * mod;
	}
	// zavrsni deo
	{
		z += lin_sum(0, x+1, br-x);
	}
	return z % MOD;
}

ll suma_nazad(ll start, const ll br) {
	if (!br) {
		return 0;
	}
	ll z = 0, x = 0;
	// dole do nule
	{
		ll y = start + 1;
		y = min(y, br);
		z += lin_sum_rev(start, 1, y);
		x = y;
	}

	if (x == br) {
		return z % MOD;
	}

	{
		ll q = (br - x) / mod;
		ll b0 = lin_sum_rev(mod-1, x+1, mod);
		ll k = mod * (mod - 1) / 2 % MOD * mod % MOD;
		// b0 + (b0 + k) + ... + (b0 + (q-1)k)
		ll s = q*b0 % MOD;
		s += q * (q-1) / 2 % MOD * k % MOD;
		z += s;
		x += q * mod;
	}
	
	{
		z += lin_sum_rev(mod-1, x+1, br-x);
	}

	return z;
}

ll suma_talas(ll start, ll br, ll sirina) {
	if (br <= 0) {
		return 0;
	}
	ll z = 0, x = 0;

	{
		ll y = mod - start;
		y = min(y, br);
		z += (start + start + y - 1) * y / 2 % MOD;
		x = y;
	}

	if (br == x) {
		return z % MOD * sirina % MOD;
	}

	{
		ll q = (br - x) / mod;
		z += mod * (mod-1) / 2 % MOD * q % MOD;
		x += q * mod;
	}

	z += (br - x) * (br - x - 1) / 2 % MOD;

	return z % MOD * sirina % MOD;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cerr.tie(nullptr);

	cin >> n >> m >> mod;
	int t;
	cin >> t;
	while (t--) {
		ll x1, y1, x2, y2;
		cin >> x1 >> y1 >> x2 >> y2;

		ll gl = (x1 + y1) % mod;
		ll dd = (x2 + y2) % mod;

		ll h = x2-x1+1;
		ll w = y2-y1+1;

		ll z = 0;

		if (h > w) {
			z += suma_napred(gl, w);
			z += suma_nazad(dd, w);

			ll sr = (gl + w) % mod;

			z += suma_talas(sr, h-w-1, w);
		} else if (w > h) {
			z += suma_napred(gl, h);
			z += suma_nazad(dd, h);

			ll sr = (gl + h) % mod;

			z += suma_talas(sr, w-h-1, h);
		} else {
			z += suma_napred(gl, w-1);
			z += suma_nazad(dd, w);
		}

		cout << z % MOD << '\n';
	}
}